/*
 * Device Template v1.1.3.final
 * Date: 2022-03-02T12:26:55Z
 * 
 * By M.Egner - SBC Support Germany 
 * 	and Niagara Community
 */
version.bajaData = '1.1.3.final'; 
var user;
var userLang;
var langXmlDoc;
var myVar = new Array(5);
var flash = false;
var setTime = new Array(5);
var stationName = false;
var actualNighttime = false;
var actualWeather = "none";
var actualOutTemperature = "none";
var actualOutHumidity = "none";
var versionPublished = false;
var dlg;
require(['jquery'], function($) {
	require(['baja!', 'dialogs', 'theme'], function(baja, dialogs, theme) {
		"use strict";
		// function to read and show data from baja
		baja.started(function() {
			//show loading Dialogbox
			dlg = dialogs.showLoading();
			// if not closed after 5sec then close.
			setTimeout(function () {
			  if(versionPublished === false){
			    dlg.close();
			    DEBUG && console.log("loading Dialogbox timeout");
			  }
			}, 10000);
			// Abrufen des Baja Benutzernamens
			user = baja.getUserName();
			//Abrufen der Sprache
			userLang = baja.getLanguage();
			async function loadData(){
				var resultStationName = await baja.Ord.make("station:|slot:/").get() // wait until the promise resolves (*)
				.then(function (station) {
					stationName = station.getStationName();
				});
				// set up file path
				// convert in useable format
				userXmlPath = correctUrl(userXmlPath);
				systemXmlPath = correctUrl(systemXmlPath);
				var langXmlFile = systemXmlPath + "lang.xml";
				var userXmlFile = userXmlPath + user + ".nav";
				var systemXmlFile = systemXmlPath + user + ".nav";
				var defaultUserFile = userXmlPath + "default" + ".nav";
				var defaultSystemFile = systemXmlPath + "default" + ".nav";
				var userXml = false; 
				var systemXml = false;
				var langXml = false; 
				var originalLang = new Array(3);
				var actualLang = new Array(3);
				
				var resultLangFile = await makeRequest(langXmlFile) // wait until the promise resolves (*)
				.then((output) => {
					langXml = output.response; 
				})
				.catch((err) =>{ //otherwise catch it
					//Set to default page
					langXml = false; 
					console.error("No language File found");
				})
				
				//************************************************//
				// loading nav files to var and check if they exist
				//************************************************//
				var resultUserFile = await makeRequest(userXmlFile) // wait until the promise resolves (*)
				.then((output) => {
					userXml = output.response; 
				})
				.catch((err) =>{ //otherwise catch it
					//Set to default page
					userXml = false; 
					console.error("No user defined user NAV-file found");
				})
				if(userXml === false){
					var resultDefaultUserFile = await makeRequest(defaultUserFile) // wait until the promise resolves (*)
					.then((output) => {
						userXml = output.response;

					})
					.catch((err) =>{ //otherwise catch it
						//Abbort
						userXml = false; 
						alert("Error: Failed to load file! | Default user NAV-file not found!");
					})
				}
				if(userXml){
					var resultSystemFile = await makeRequest(systemXmlFile) // wait until the promise resolves (*)
					.then((output) => {
						systemXml = output.response; 
					})
					.catch((err) =>{ //otherwise catch it
						//Set to default page
						systemXml = false;
						console.error("No user defined user NAV-file found");						
					})
					if(systemXml === false){
						var resultDefaultSystemFile = await makeRequest(defaultSystemFile) // wait until the promise resolves (*)
						.then((output) => {
							systemXml = output.response; 
						})
						.catch((err) =>{ //otherwise catch it
							//Abbort
							systemXml = false; 
							alert("Error: Failed to load file! | Default system NAV-file not found!");
						})
					}
				}
				
				var parser = new DOMParser();
				
				//parse loaded content and check if needed content exist
				if(langXml){					
					langXmlDoc = parser.parseFromString(langXml, "application/xml");
					if(!langXmlDoc.getElementsByTagName("lang").length) {
						langXml = false;
						langXmlDoc = false;
						console.error("Error: Failed to find xml tree in the language file!");
					} 
				}
				if(userXml){					
					var userXmlDoc = parser.parseFromString(userXml, "application/xml");
					if(!userXmlDoc.getElementsByTagName("nav").length) {
						userXml = false;
						console.error("Error: Failed to find nav tree of the user NAV-file!");
					} else {
						readUserXml(userXmlDoc); //run if exist
					}
				}
				if(systemXml){
					var systemXmlDoc = parser.parseFromString(systemXml, "application/xml");
					if(!userXmlDoc.getElementsByTagName("nav").length) {
						systemXml = false;
						console.error("Error: Failed to find nav tree of the system NAV-file!");
					} else {
						readSystemXml(systemXmlDoc); //run if exist
					}
				}
				//only run if exists
				if(systemXml){ /*change if needed (userXml && systemXml)*/
					//Check if nav file has needed nodes an run only things which exists
					
					var homeNode = false;
					var alarmlistElement = false;
					var datapointsElement = false;
					
					if(systemXmlDoc.getElementsByTagName("nav")[0].children.length) {
						homeNode = systemXmlDoc.getElementsByTagName("nav")[0].children[0]; 
					} else {
						console.error("Error: Failed to find 'home' node in nav tree of the system NAV-file!");
					}
					var homeNodeLength = homeNode.children.length;
					
					if(homeNodeLength >= 3) {
						alarmlistElement = homeNode.children[2]; 
					} else {
						console.error("Error: Failed to find 'alarmlist' node in nav-tree of the system NAV-file!");
						alarmlistElement = false;
					}
					if(homeNodeLength >= 4) {
						datapointsElement = homeNode.children[3]; 
					} else {
						console.error("Error: Failed to find 'datapoint' node in nav-tree of the system NAV-file!");
						datapointsElement = false;
					}
					
					var subTemperature = new baja.Subscriber();
					var subHumidity = new baja.Subscriber();
					var subWeather = new baja.Subscriber();
					var subNighttime = new baja.Subscriber();
					//if datapoints exist then use it
					if(datapointsElement) {					
						// read baja temperature.
						var updateTemp = function() {
							DEBUG && console.group("*****updateTemp Function*****");
							actualOutTemperature = this.getOut().getValueDisplay();
							loadTempHumidity();
						};
						
						if(datapointsElement.children.length){
							if($(datapointsElement.children[0]).attr("ord") !== "none" && $(datapointsElement.children[0]).attr("ord") !== "null" && $(datapointsElement.children[0]).attr("ord") !== "") {
								subTemperature.attach("changed", updateTemp);
								baja.Ord.make($(datapointsElement.children[0]).attr("ord")).get({
									subscriber: subTemperature
								});
							}
						}
						// read baja humidity.
						var updateHumidity = function() {
							DEBUG && console.group("*****updateHumidity Function*****");
							actualOutHumidity = this.getOut().getValueDisplay();
							loadTempHumidity();
						};
						
						if(datapointsElement.children.length > 1){
							if($(datapointsElement.children[1]).attr("ord") !== "none" && $(datapointsElement.children[1]).attr("ord") !== "null" && $(datapointsElement.children[1]).attr("ord") !== "") {
								subHumidity.attach("changed", updateHumidity);
								baja.Ord.make($(datapointsElement.children[1]).attr("ord")).get({
									subscriber: subHumidity
								});
							}
						}
						// read baja weather.
						var updateWeather = function() {
							actualWeather = this.getOut().getValueDisplay();
							DEBUG && console.group("*****updateWeather Function*****");
							loadWeather();
						};
						// read baja nighttime
						var updateNighttime = function() {
							actualNighttime = this.getOut().getValueDisplay();
							DEBUG && console.group("*****updateNighttime Function*****");
							loadWeather();
						};
						if(datapointsElement.children.length > 3){
							if($(datapointsElement.children[2]).attr("ord") !== "none" && $(datapointsElement.children[2]).attr("ord") !== "null" && $(datapointsElement.children[2]).attr("ord") !== "") {
								subWeather.attach("changed", updateWeather);
								baja.Ord.make($(datapointsElement.children[2]).attr("ord")).get({
									subscriber: subWeather
								});
								if($(datapointsElement.children[3]).attr("ord") !== "none" && $(datapointsElement.children[3]).attr("ord") !== "null" && $(datapointsElement.children[3]).attr("ord") !== "") {
									subNighttime.attach("changed", updateNighttime);
									baja.Ord.make($(datapointsElement.children[3]).attr("ord")).get({
										subscriber: subNighttime
									});
								}
							}
						}
						
						
						
					}
					// read baja time.
					var updateTime = function() {
						// set the time in the userconfiguration of niagara to HH:mm - DD.MM.YYYY or anything you want
						DEBUG && console.group("*****Time Function*****");
                                          var date = new Date();
                                          var dateTime = baja.AbsTime.make({ jsDate: date });
                                          // the offset will be converted from JS Date style to BAbsTime style.
                                          DEBUG && console.log("DateTime: "+ dateTime);
                                          dateTime.toDateTimeString().then(function(dateTimeStr) {
                                                 document.getElementById("date_time").innerHTML = dateTimeStr;
                                                 DEBUG && console.log("Converted: "+ dateTimeStr);
                                          });
                                          DEBUG && console.groupEnd();
						
						//if header logo is fully loaded then trigger loadHeader function
						if((document.getElementsByClassName('header-text-logo')[0].style.display != "none") && (typeof headerLogoWidth !== 'undefined')) {
							var headerLogoElement = document.getElementsByClassName('header-text-logo')[0];
							var headerLogoPositionInfo = headerLogoElement.getBoundingClientRect();
							var headerLogoWidthTemp = Math.round(headerLogoPositionInfo.width);
							if((headerLogoWidth != headerLogoWidthTemp) && (headerLogoWidthTemp != 70)){
								DEBUG && console.log("loadHeader cause headerLogoWidth has changed");
								loadHeader();
							}
						}
						
						//load Version Info
						if(versionPublished === false) {
							if((typeof version.index !== 'undefined') && (typeof version.index !== 'undefined') && (typeof version.bajaData !== 'undefined') && (typeof version.theme !== 'undefined') && (typeof version.jpanelmenu !== 'undefined') && (typeof version.createMenu !== 'undefined')) {
								console.group("***** DeviceTemplate *****");
								console.log("Fully loaded!");
								console.group("Version Information:")
								console.log({"index.html":  version.index});
								console.log({"bajaData.js": version.bajaData});
								console.log({"theme.js": version.theme});
								console.log({"jpanelmenu.js": version.jpanelmenu});
								console.log({"createMenu.js": version.createMenu});
								console.groupEnd();
								console.groupEnd();
								dlg.close(); //if fully loaded then close loading dialog
								versionPublished = true;
							}
						}
						
					};
					setInterval(function() {
							updateTime();
						}, 1000);
					
					//set up alarming if alarming exist!
					if(alarmlistElement.children.length) {
						var almSub = new baja.Subscriber();
						var alarmClassPrio = new Array(alarmlistElement.children.length);
						var subAlarmClassPrio = new Array(alarmlistElement.children.length);
						var statusAlarmClassPrio = new Array(alarmlistElement.children.length);
						
						//define every alarmclasses which exist
						for (var i = 0; i < alarmlistElement.children.length; i++) {
							if(alarmlistElement.children[i].children.length > 2){
								alarmClassPrio[i] = $(alarmlistElement.children[i].children[0]).attr("ord");
								subAlarmClassPrio[i] = new baja.Subscriber();
								statusAlarmClassPrio[i] = "init";
							} else {
								console.error("Error: Failed to find child nodes of 'alarmlist' node in nav-tree of the system NAV-file!");
							}
							
							
						}
						
						// changeing the alarm icon in the header of the menu corresponding to situation of alarming
						function updateSumAlarm() {
							if (statusAlarmClassPrio.includes("alarm")) {
								document.getElementById("alarmIcon").src = imageAlarmActive;
							} else if (statusAlarmClassPrio.includes("ack")) {
								document.getElementById("alarmIcon").src = imageAlarmAck;
							} else {
								document.getElementById("alarmIcon").src = imageAlarm;
							}
						}

						var inAlarmCountAlarmClassPrio = new Array(alarmlistElement.children.length);
						var unackedCountAlarmClassPrio = new Array(alarmlistElement.children.length);
						
						//changing colors of alarmlist if alarm is activ and flashing if new alarms are incoming
						var updateAlarmClassPrio = function(i) {
							var pulseAlarmPrio = false;
							var index = i + 1;
							var pulseTimePrio = $(alarmlistElement.children[i].children[1]).attr("ord");
							
							if(pulseTimePrio !== "none" && pulseTimePrio !== "null" && pulseTimePrio !== "") {
								pulseAlarmPrio = true;
								pulseTimePrio = (pulseTimePrio * 1000) /2;
							} else {
								pulseAlarmPrio = false
							}
							
							var colorPrio = $(alarmlistElement.children[i].children[2]).attr("ord");
								
							if (inAlarmCountAlarmClassPrio[i] === 0 && unackedCountAlarmClassPrio[i] === 0) {
								document.getElementById("bodyAlarmlistPrio0"+index).style.backgroundColor = "transparent";
								document.getElementById("bodyAlarmlistPrio0"+index).style.color = "#404040";
								statusAlarmClassPrio[i] = "normal";
								if(myVar[i]){
									clearInterval(myVar[i]);
									myVar[i] = false;
								}
							} else if (inAlarmCountAlarmClassPrio[i] > 0 && unackedCountAlarmClassPrio[i] > 0 && pulseAlarmPrio) {
								document.getElementById("bodyAlarmlistPrio0"+index).style.color = "white";
								statusAlarmClassPrio[i] = "alarm";
								if(!myVar[i]){
									myVar[i] = setInterval(setFlash, pulseTimePrio, document.getElementById("bodyAlarmlistPrio0"+index),colorPrio);
								}
							} else {
								document.getElementById("bodyAlarmlistPrio0"+index).style.backgroundColor = colorPrio;
								document.getElementById("bodyAlarmlistPrio0"+index).style.color = "white";
								statusAlarmClassPrio[i] = "ack";
								if(myVar[i]){
									clearInterval(myVar[i]);
									myVar[i] = false;
								}
							}
							document.getElementById("bodyAlarmlistPrio0"+index).innerHTML = inAlarmCountAlarmClassPrio[i] + " / " + unackedCountAlarmClassPrio[i];

							setTimeout(function() {
								updateSumAlarm();
							}, 5000);

						};

						//Set up vars for alarming
						var updateAlarmClassPrio01 = function() {
							inAlarmCountAlarmClassPrio[0] = this.getInAlarmCount();
							unackedCountAlarmClassPrio[0] = this.getUnackedAlarmCount();
							updateAlarmClassPrio(0);
						}
						var updateAlarmClassPrio02 = function() {
							inAlarmCountAlarmClassPrio[1] = this.getInAlarmCount();
							unackedCountAlarmClassPrio[1] = this.getUnackedAlarmCount();
							updateAlarmClassPrio(1);
						}
						var updateAlarmClassPrio03 = function() {
							inAlarmCountAlarmClassPrio[2] = this.getInAlarmCount();
							unackedCountAlarmClassPrio[2] = this.getUnackedAlarmCount();
							updateAlarmClassPrio(2);
						}
						var updateAlarmClassPrio04 = function() {
							inAlarmCountAlarmClassPrio[3] = this.getInAlarmCount();
							unackedCountAlarmClassPrio[3] = this.getUnackedAlarmCount();
							updateAlarmClassPrio(3);
						}
						var updateAlarmClassPrio05 = function() {
							inAlarmCountAlarmClassPrio[4] = this.getInAlarmCount();
							unackedCountAlarmClassPrio[4] = this.getUnackedAlarmCount();
							updateAlarmClassPrio(4);
						}

						if(alarmlistElement.children[0].children.length > 2){
							if($(alarmlistElement.children[0]).attr("ord") !== "none" && $(alarmlistElement.children[0]).attr("ord") !== "null" && $(alarmlistElement.children[0]).attr("ord") !== "") {
								//set up alarmlist 1
								subAlarmClassPrio[0].attach("changed", updateAlarmClassPrio01);
								baja.Ord.make(alarmClassPrio[0]).get({
									subscriber: subAlarmClassPrio[0]
							});
							} else {
								//do nothing
							}
						}
						if(alarmlistElement.children[1].children.length > 2){
							if($(alarmlistElement.children[1]).attr("ord") !== "none" && $(alarmlistElement.children[1]).attr("ord") !== "null" && $(alarmlistElement.children[1]).attr("ord") !== "") {
								//set up alarmlist 1
								subAlarmClassPrio[1].attach("changed", updateAlarmClassPrio02);
								baja.Ord.make(alarmClassPrio[1]).get({
									subscriber: subAlarmClassPrio[1]
							});
							} else {
								//do nothing
							}
						}
						if(alarmlistElement.children[2].children.length > 2){
							if($(alarmlistElement.children[2]).attr("ord") !== "none" && $(alarmlistElement.children[2]).attr("ord") !== "null" && $(alarmlistElement.children[2]).attr("ord") !== "") {
								//set up alarmlist 1
								subAlarmClassPrio[2].attach("changed", updateAlarmClassPrio03);
								baja.Ord.make(alarmClassPrio[2]).get({
									subscriber: subAlarmClassPrio[2]
							});
							} else {
								//do nothing
							}
						}
						if(alarmlistElement.children[3].children.length > 2){
							if($(alarmlistElement.children[3]).attr("ord") !== "none" && $(alarmlistElement.children[3]).attr("ord") !== "null" && $(alarmlistElement.children[3]).attr("ord") !== "") {
								//set up alarmlist 1
								subAlarmClassPrio[3].attach("changed", updateAlarmClassPrio04);
								baja.Ord.make(alarmClassPrio[3]).get({
									subscriber: subAlarmClassPrio[3]
							});
							} else {
								//do nothing
							}
						}
						if(alarmlistElement.children[4].children.length > 2){
							if($(alarmlistElement.children[4]).attr("ord") !== "none" && $(alarmlistElement.children[4]).attr("ord") !== "null" && $(alarmlistElement.children[4]).attr("ord") !== "") {
								//set up alarmlist 1
								subAlarmClassPrio[4].attach("changed", updateAlarmClassPrio05);
								baja.Ord.make(alarmClassPrio[4]).get({
									subscriber: subAlarmClassPrio[4]
							
							});
							} else {
								//do nothing
							}
						}

						setInterval(function() {
							updateSumAlarm();
						}, 5000);
					} else {
						console.error("Error: Failed to find 'alarmlist' node in nav-tree of the system NAV-file!");
					}
				}
				//loadHeader(); //load header after creation
			}
			loadData();
		});
		//var hostip = location.host;
		
	});
	/* Function for loading the navigation menu depending on the logged in user*/	

	var makeRequest = function (url) {

		// Create the XHR request
		var request = new XMLHttpRequest();

		// Return it as a Promise
		return new Promise(function (resolve, reject) {
			
			// Setup our listener to process compeleted requests
			request.onreadystatechange = function () {

				// Only run if the request is complete
				if (request.readyState !== 4) return;

				// Process the response
				if (request.status >= 200 && request.status < 300) {
					// If successful
					resolve(request);
				} else {
					// If failed
					reject({
						status: request.status,
						statusText: request.statusText
					});
				}

			};

			// Setup our HTTP request
			request.open('GET', url, true);
			request.setRequestHeader("Content-Type", "text/xml");

			// Send the request
			request.send();

		});
	};

	/* Change niagara specific path to a dictionary js can handle with */
	function correctUrl(userXmlFile) {
		
		var stringUrlNiagara = "file:^";
		var stringUrlNiagara2 = "station:|file:^";
		var stringUrlNeeded = "/file/";
		// Convert in useable format
		if(userXmlFile.startsWith(stringUrlNiagara)) {
			return userXmlFile.replace(stringUrlNiagara, stringUrlNeeded);
		} else if (userXmlFile.startsWith(stringUrlNiagara2)) {
			return userXmlFile.replace(stringUrlNiagara2, stringUrlNeeded);
		};
	}


	function orgLangToNew(langFile, orgLang) {
		DEBUG && console.group("*****Translator Function*****");
		var translation = false;
		if(langFile){
			var langString = langFile.getElementById(orgLang);
			
			if(langString) {
				for (var i = 0; i < langString.children.length; i++){
					if($(langString.children[i]).attr("lang") === userLang){
						translation = $(langString.children[i]).attr("translation");
					}
				}
			}
		}
		if(translation) {
			DEBUG && console.log("translated:" + translation);
			DEBUG && console.groupEnd();
			return translation
		} else {
			DEBUG && console.log("not translated:" + orgLang);
			DEBUG && console.groupEnd();
			return orgLang
		}
	}
	
	function loadTempHumidity() {
		if((actualOutTemperature === "none") && (actualOutHumidity === "none")) {
			DEBUG && console.log("No temperature or humidity info");
			//Do nothing
		} else if((actualOutTemperature === "none") && (actualOutHumidity !== "none")) {
			DEBUG && console.log("Humidity set only");
			document.getElementById("temperature").innerHTML = orgLangToNew(langXmlDoc, "Out") + ": " + actualOutHumidity;
		} else if((actualOutTemperature !== "none") && (actualOutHumidity === "none")) {
			DEBUG && console.log("Temperature set only");
			document.getElementById("temperature").innerHTML = orgLangToNew(langXmlDoc, "Out") + ": " + actualOutTemperature;
		} else {
			DEBUG && console.log("Temperature and Humidity set");
			document.getElementById("temperature").innerHTML = orgLangToNew(langXmlDoc, "Out") + ": " + actualOutTemperature + "&nbsp;| " + actualOutHumidity;
		}
		DEBUG && console.log({actualOutTemperature});
		DEBUG && console.log({actualOutHumidity});
		DEBUG && console.groupEnd();
	}

	function loadWeather() {
		var weatherStateText = false;
		var weatherStateImage = false;
		var orderLength = orderWeather.length -1;
		if(orderLength < actualWeather) {
			console.error('Weather state out of range! max:'+ orderLength +'| Actual Value:' + actualWeather);
			weatherStateText = "Unknown";
			weatherStateImage = imagesWeatherDay[weatherStateText];
		} else if(actualWeather === "none"){
			console.warn('Weather state not set or point does not exist');
			weatherStateText = "Unknown";
			weatherStateImage = imagesWeatherDay[weatherStateText];
		} else {
			if(actualNighttime === "true") {
				DEBUG && console.log("Nighttime activ");
				weatherStateText = orderWeather[actualWeather];
				weatherStateImage = imagesWeatherNight[weatherStateText];
			} else {
				DEBUG && console.log("Daytime activ");
				weatherStateText = orderWeather[actualWeather];
				weatherStateImage = imagesWeatherDay[weatherStateText];
			}
		}
		DEBUG && console.log({actualNighttime});
		DEBUG && console.log('weatherStateText: ' + weatherStateText);
		DEBUG && console.log('weatherStateImage: ' + weatherStateImage);
		if(weatherStateImage) {
			var stateTextTemp = orgLangToNew(langXmlDoc, weatherStateText)
			document.getElementById("weather").innerHTML = '<img src="' + weatherStateImage + '" alt="Logo" />&nbsp;-&nbsp;' + stateTextTemp;
			DEBUG && console.log("Weather fully loaded");
		}
		console.groupEnd();
	}

	function setFlash(x, color1,) {
	  if(x.style.backgroundColor !== "white") {
		  x.style.backgroundColor = "white";
		  x.style.color = "#404040";

	  } else {
		  x.style.backgroundColor = color1;
		  x.style.color = "white";

	  }
	}


	function readUserXml(userXmlDoc){
		//read userspecific nav-file and creat menu
		
		var navElement = userXmlDoc.getElementsByTagName("nav");
		var pageFullscreen = "";
		//creating menu
		var ulMain = $("<ul id='menu5' class='example_menu' />");
		var firstNode = navElement[0].children[0]; //first single element to start with
		//check if fullscreen is already definded and if not then set fullscreen tot true
		if ($(firstNode).attr("ord").includes("fullScreen=")) {
			pageFullscreen = "";
		} else if ($(firstNode).attr("ord").includes("view:")) {
			pageFullscreen = "?fullScreen=true";
		} else {
			pageFullscreen = "|view:?fullScreen=true";
		}
		
		//check url/ord and set up hyperlink-tag foreach posibility
		if ($(firstNode).attr("ord").substring(0, 4) == "http" || $(firstNode).attr("ord").substring(0, 5) == "https" || $(firstNode).attr("ord").substring(0, 3) == "ftp" || $(firstNode).attr("ord").substring(0, 3) == "www") {
			ulMain.append("<li><a target='content' href=" + $(firstNode).attr("ord") + "'>" + $(firstNode).attr("name") + "</a></li>");
			document.getElementsByTagName("iframe")[0].src = $(firstNode).attr("ord");
		} else if ($(firstNode).attr("ord").substring(0, 7) == "station" || $(firstNode).attr("ord").substring(0, 7) == "/tunnel" || $(firstNode).attr("ord").substring(0, 4) == "file") {
			ulMain.append("<li><a target='content' href='/" + "ord?" + $(firstNode).attr("ord") + pageFullscreen + "'>" + $(firstNode).attr("name") + "</a></li>");
			document.getElementsByTagName("iframe")[0].src = "/ord?" + $(firstNode).attr("ord") + pageFullscreen;
		} else if ($(firstNode).attr("ord") === "") {
			ulMain.append("<li><a target='content' >" + $(firstNode).attr("name") + "</a></li>");
		} else {
			ulMain.append("<li><a target='content' href='/" + $(firstNode).attr("ord") + pageFullscreen + "'>" + $(firstNode).attr("name") + "</a></li>");
			document.getElementsByTagName("iframe")[0].src = "/" + $(firstNode).attr("ord") + pageFullscreen;
		}
		var menuNode = navElement[0].children;
		var ulOpenTag = $("<ul>");
		var ulCloseTag = $("</ul>");
		var li = "";
		
		//if first menu level is defined setup the menu foreach element
		if(menuNode[0].children.length) {
			var menuNodeLength = menuNode[0].children.length;
			for (var i = 0; i < menuNodeLength; i++) {
				var temp = menuNode[0].children[i];
				var level2 = $("<ul />");
				var li = "";
				//check if fullscreen is already definded and if not then set fullscreen tot true
				if ($(temp).attr("ord").includes("fullScreen=")) {
					pageFullscreen = "";
				} else if ($(temp).attr("ord").includes("view:")) {
					pageFullscreen = "?fullScreen=true";
				} else {
					pageFullscreen = "|view:?fullScreen=true";
				}
				//stationName
				if ($(temp).attr("ord").includes("?stationName")) {
					$(temp).attr("ord", $(temp).attr("ord").replace("?stationName", stationName));
				}
				//check url/ord and set up hyperlink-tag foreach posibility
				if ($(temp).attr("ord").substring(0, 4) == "http" || $(temp).attr("ord").substring(0, 5) == "https" || $(temp).attr("ord").substring(0, 3) == "ftp" || $(temp).attr("ord").substring(0, 3) == "www") {
					li = $("<li><a class='collapsed haschildren' target='content' href='" + $(temp).attr("ord") + "'>" + $(temp).attr("name") + "</a></li>");
				} else if ($(temp).attr("ord").substring(0, 7) == "station" || $(temp).attr("ord").substring(0, 7) == "/tunnel" || $(temp).attr("ord").substring(0, 7) == "history" || $(temp).attr("ord").substring(0, 4) == "file") {
					li = $("<li><a class='collapsed haschildren' target='content' href='/" + "ord?" + $(temp).attr("ord") + pageFullscreen + "'>" + $(temp).attr("name") + "</a></li>");
				} else if (($(temp).attr("ord") === "") || ($(temp).attr("ord") === "null")) {
					li = $("<li><a class='collapsed haschildren' target='content' >" + $(temp).attr("name") + "</a></li>");
				} else {
					li = $("<li><a class='collapsed haschildren' target='content' href='/" + $(temp).attr("ord") + pageFullscreen + "'>" + $(temp).attr("name") + "</a></li>");
				}
				var li2 = "";
				
				//if second menu level is defined setup the menu foreach element
				if (menuNode[0].children[i].children.length) {					
					var subMenuNodeLength = menuNode[0].children[i].children.length;
					for (var i2 = 0; i2 < subMenuNodeLength; i2++) {
						var temp2 = menuNode[0].children[i].children[i2];
						var level3 = $("<ul />");
						var li3 = "";
						//check if fullscreen is already definded and if not then set fullscreen tot true
						if ($(temp2).attr("ord").includes("fullScreen=")) {
							pageFullscreen = "";
						} else if ($(temp2).attr("ord").includes("view:")) {
							pageFullscreen = "?fullScreen=true";
						} else {
							pageFullscreen = "|view:?fullScreen=true";
						}
						//stationName
						if ($(temp2).attr("ord").includes("?stationName")) {
							$(temp2).attr("ord", $(temp2).attr("ord").replace("?stationName", stationName));
						}
						//check url/ord and set up hyperlink-tag foreach posibility
						if ($(temp2).attr("ord").substring(0, 4) == "http" || $(temp2).attr("ord").substring(0, 5) == "https" || $(temp2).attr("ord").substring(0, 3) == "ftp" || $(temp2).attr("ord").substring(0, 3) == "www") {
							li2 = $("<li><a class='collapsed haschildren level2' target='content' href='" + $(temp2).attr("ord") + "'>" + $(temp2).attr("name") + "</a></li>");
						} else if ($(temp2).attr("ord").substring(0, 7) == "station" || $(temp2).attr("ord").substring(0, 7) == "/tunnel" || $(temp2).attr("ord").substring(0, 7) == "history" || $(temp2).attr("ord").substring(0, 4) == "file") {
							li2 = $("<li><a class='collapsed haschildren level2' target='content' href='/" + "ord?" + $(temp2).attr("ord") + pageFullscreen + "'>" + $(temp2).attr("name") + "</a></li>");
						} else if (($(temp2).attr("ord") === "") || ($(temp2).attr("ord") === "null")) {
							li2 = $("<li><a class='collapsed haschildren level2' target='content' >" + $(temp2).attr("name") + "</a></li>");
						} else {
							li2 = $("<li><a class='collapsed haschildren level2' target='content' href='/" + $(temp2).attr("ord") + pageFullscreen + "'>" + $(temp2).attr("name") + "</a></li>");
						}
						
						//if third menu level is defined setup the menu foreach element
						if (menuNode[0].children[i].children[i2].children.length) {					
							var subSubMenuNodeLength = menuNode[0].children[i].children[i2].children.length;
							for (var i3 = 0; i3 < subSubMenuNodeLength; i3++) {
								var temp3 = menuNode[0].children[i].children[i2].children[i3];
								var level4 = $("<ul />");
								var li4 = "";
								//check if fullscreen is already definded and if not then set fullscreen tot true
								if ($(temp3).attr("ord").includes("fullScreen=")) {
									pageFullscreen = "";
								} else if ($(temp3).attr("ord").includes("view:")) {
									pageFullscreen = "?fullScreen=true";
								} else {
									pageFullscreen = "|view:?fullScreen=true";
								}
								//stationName
								if ($(temp3).attr("ord").includes("?stationName")) {
									$(temp3).attr("ord", $(temp3).attr("ord").replace("?stationName", stationName));
								}
								//check url/ord and set up hyperlink-tag foreach posibility
								if ($(temp3).attr("ord").substring(0, 4) == "http" || $(temp3).attr("ord").substring(0, 5) == "https" || $(temp3).attr("ord").substring(0, 3) == "ftp" || $(temp3).attr("ord").substring(0, 3) == "www") {
									li3 = $("<li><a class='collapsed haschildren level3' target='content' href='" + $(temp3).attr("ord") + "'>" + $(temp3).attr("name") + "</a></li>");
								} else if ($(temp3).attr("ord").substring(0, 7) == "station" || $(temp3).attr("ord").substring(0, 7) == "/tunnel" || $(temp3).attr("ord").substring(0, 7) == "history" || $(temp3).attr("ord").substring(0, 4) == "file") {
									li3 = $("<li><a class='collapsed haschildren level3' target='content' href='/" + "ord?" + $(temp3).attr("ord") + pageFullscreen + "'>" + $(temp3).attr("name") + "</a></li>");
								} else if (($(temp3).attr("ord") === "") || ($(temp3).attr("ord") === "null")) {
									li3 = $("<li><a class='collapsed haschildren level3' target='content' >" + $(temp3).attr("name") + "</a></li>");
								} else {
									li3 = $("<li><a class='collapsed haschildren level3' target='content' href='/" + $(temp3).attr("ord") + pageFullscreen + "'>" + $(temp3).attr("name") + "</a></li>");
								}
								
								//if fourth menu level is defined setup the menu foreach element
								if (menuNode[0].children[i].children[i2].children[i3].children.length) {					
									var pageMenuNodeLength = menuNode[0].children[i].children[i2].children[i3].children.length;
									for (var i4 = 0; i4 < pageMenuNodeLength; i4++) {
										var temp4 = menuNode[0].children[i].children[i2].children[i3].children[i4];
										//check if fullscreen is already definded and if not then set fullscreen tot true
										if ($(temp4).attr("ord").includes("fullScreen=")) {
											pageFullscreen = "";
										} else if ($(temp4).attr("ord").includes("view:")) {
											pageFullscreen = "?fullScreen=true";
										} else {
											pageFullscreen = "|view:?fullScreen=true";
										}
										//stationName
										if ($(temp4).attr("ord").includes("?stationName")) {
											$(temp4).attr("ord", $(temp4).attr("ord").replace("?stationName", stationName));
										}
										//check url/ord and set up hyperlink-tag foreach posibility
										if ($(temp4).attr("ord").substring(0, 4) == "http" || $(temp4).attr("ord").substring(0, 5) == "https" || $(temp4).attr("ord").substring(0, 3) == "ftp" || $(temp4).attr("ord").substring(0, 3) == "www") {
											level4.append("<li><a class='collapsed haschildren level4' target='content' href='" + $(temp4).attr("ord") + "'>" + $(temp4).attr("name") + "</a></li>");
										} else if ($(temp4).attr("ord").substring(0, 7) == "station" || $(temp4).attr("ord").substring(0, 7) == "/tunnel" || $(temp4).attr("ord").substring(0, 7) == "history" || $(temp4).attr("ord").substring(0, 4) == "file") {
											level4.append("<li><a class='collapsed haschildren level4' target='content' href='/" + "ord?" + $(temp4).attr("ord") + pageFullscreen + "'>" + $(temp4).attr("name") + "</a></li>");
										} else if (($(temp4).attr("ord") === "") || ($(temp4).attr("ord") === "null")) {
											level4.append("<li><a class='collapsed haschildren level4' target='content' >" + $(temp4).attr("name") + "</a></li>");
										} else {
											level4.append("<li><a class='collapsed haschildren level4' target='content' href='/" + $(temp4).attr("ord") + pageFullscreen + "'>" + $(temp4).attr("name") + "</a></li>");
										}
									}	
								}
								ulMain.append(li.append(level2.append(li2.append(level3.append(li3.append(level4))))));
							}

						}
						ulMain.append(li.append(level2.append(li2.append(level3.append(li3)))));
					}
				}
				ulMain.append(li.append(level2.append(li2)));
			}
		} //Else no Nodes
		
		
		
		
		
		ulMain.append("</ul>");
		$("#menu_wrapper").append(ulMain);


		UpdateMenu();
	}


	function readSystemXml(systemXmlDoc){	

		//Find anchorurl from xml and place anchor and imgicon in the nav-bar-iconpanel
		var anchorwithimg;
		var homeNode = false;
		var headerElement = false;
		var quickmenuElement = false;
		var alarmlistElement = false;
		var datapointsElement = false;
		
		if(systemXmlDoc.getElementsByTagName("nav")[0].children.length && $(systemXmlDoc.getElementsByTagName("nav")[0].children[0]).attr("name") == 'Home') {
			homeNode = systemXmlDoc.getElementsByTagName("nav")[0].children[0];
			if(homeNode.children.length >= 1 && $(homeNode.children[0]).attr("name") == 'header') {
				headerElement = homeNode.children[0];
				if(homeNode.children.length >= 2 && $(homeNode.children[1]).attr("name") == 'quickmenu') {
					quickmenuElement = homeNode.children[1]; 
					if(homeNode.children.length >= 3 && $(homeNode.children[2]).attr("name") == 'alarmlist') {
						alarmlistElement = homeNode.children[2];
						if(homeNode.children.length >= 4 && $(homeNode.children[3]).attr("name") == 'datapoints') {
							datapointsElement = homeNode.children[3]; 
						} else {
							console.error("Error: Failed to find 'datapoints' node in nav-tree of the system NAV-file!");
						}
					} else {
						console.error("Error: Failed to find 'alarmlist' node in nav-tree of the system NAV-file!");
					}
				} else {
					console.error("Error: Failed to find 'quickmenu' node in nav-tree of the system NAV-file!");
				}
			} else {
				console.error("Error: Failed to find 'header' node in nav-tree of the system NAV-file!");
			}
		} else {
			console.error("Error: Failed to find 'Home' node in nav tree of the system NAV-file!");
		}

		if(headerElement){
			//define header text
			var CustomText = headerElement.children[0];
			$("#userdefined-text").append($(CustomText).attr("name"));
			//define title 
			document.title = $(CustomText).attr("name");
			//write username
			document.getElementById("user").innerHTML = orgLangToNew(langXmlDoc, "User") + ": " + user;
			//set logo left
			if($(headerElement.children[2]).attr("ord") !== "none" && $(headerElement.children[2]).attr("ord") !== "null" && $(headerElement.children[2]).attr("ord") !== "") {
				var headerLogoLeft = correctUrl($(headerElement.children[2]).attr("ord"));
				document.getElementById("nav-bar-logo").children[0].children[0].src = headerLogoLeft;
			}
			//set logo right
			if($(headerElement.children[1]).attr("ord") !== "none" && $(headerElement.children[1]).attr("ord") !== "null" && $(headerElement.children[1]).attr("ord") !== "") {
				var headerLogoRight = correctUrl($(headerElement.children[1]).attr("ord"));
				document.getElementById("header-logo").children[0].children[0].src = headerLogoRight;
			}
			
		}
		
		if(quickmenuElement){
			var quickmenuCounter = 0;
			var alarmNode = quickmenuElement.children[0];
			if($(alarmNode).attr("ord") !== "none" && $(alarmNode).attr("ord") !== "null" && $(alarmNode).attr("ord") !== "") {
				var pageFullscreen;
				if ($(alarmNode).attr("ord").includes("fullScreen=")) {
					pageFullscreen = "";
				} else if ($(alarmNode).attr("ord").includes("view:")) {
					pageFullscreen = "?fullScreen=true";
				} else {
					pageFullscreen = "|view:?fullScreen=true";
				}
				anchorwithimg = $("<a title='" + $(alarmNode).attr("name") + "' target='content' href='/" + "ord?" + $(alarmNode).attr("ord") + pageFullscreen + "'>" + "<img src='"+ imageAlarm +"' id='alarmIcon' />" + "</a>");
				$(".nav-bar-iconpanel").append(anchorwithimg);
			} else {
				anchorwithimg = $("<a title='alarmnode' target='content' style='display:none'>" + "<img src='' id='alarmIcon' style='display:none'/>" + "</a>");
				$(".nav-bar-iconpanel").append(anchorwithimg);
				quickmenuCounter++; //increment if not in use
			}
			var graphNode = quickmenuElement.children[1];
			if($(graphNode).attr("ord") !== "none" && $(graphNode).attr("ord") !== "null" && $(graphNode).attr("ord") !== "") {
				var pageFullscreen;	
				if ($(graphNode).attr("ord").includes("fullScreen=")) {
					pageFullscreen = "";
				} else if ($(graphNode).attr("ord").includes("view:")) {
					pageFullscreen = "?fullScreen=true";
				} else {
					pageFullscreen = "|view:?fullScreen=true";
				}
				anchorwithimg = $("<a title='" + $(graphNode).attr("name") + "' target='content' href='/" + "ord?" + $(graphNode).attr("ord") + pageFullscreen + "'>" + "<img src='"+ imageTrend +"' />" + "</a>");
				$(".nav-bar-iconpanel").append(anchorwithimg);
			} else {
				anchorwithimg = $("<a title='alarmnode' target='content' style='display:none'>" + "<img src='' id='alarmIcon' style='display:none'/>" + "</a>");
				$(".nav-bar-iconpanel").append(anchorwithimg);
				quickmenuCounter++; //increment if not in use
			}
			var userNode = quickmenuElement.children[2];
			if($(userNode).attr("ord") !== "none" && $(userNode).attr("ord") !== "null" && $(userNode).attr("ord") !== "") {
				var pageFullscreen;
				if ($(userNode).attr("ord").includes("fullScreen=")) {
					pageFullscreen = "";
				} else if ($(userNode).attr("ord").includes("view:")) {
					pageFullscreen = "?fullScreen=true";
				} else {
					pageFullscreen = "|view:?fullScreen=true";
				}
				anchorwithimg = $("<a title='" + $(userNode).attr("name") + "' target='content' href='/" + "ord?" + $(userNode).attr("ord") + pageFullscreen + "'>" + "<img src='"+ imageUser +"' />" + "</a>");
				$(".nav-bar-iconpanel").append(anchorwithimg);
			} else {
				anchorwithimg = $("<a title='alarmnode' target='content' style='display:none'>" + "<img src='' id='alarmIcon' style='display:none'/>" + "</a>");
				$(".nav-bar-iconpanel").append(anchorwithimg);
				quickmenuCounter++; //increment if not in use
			}		
			var searchNode = quickmenuElement.children[3];
			if($(searchNode).attr("ord") !== "none" && $(searchNode).attr("ord") !== "null" && $(searchNode).attr("ord") !== "") {
				var pageFullscreen;
				if ($(searchNode).attr("ord").includes("fullScreen=")) {
					pageFullscreen = "";
				} else if ($(searchNode).attr("ord").includes("view:")) {
					pageFullscreen = "?fullScreen=true";
				} else {
					pageFullscreen = "|view:?fullScreen=true";
				}
				anchorwithimg = $("<a title='" + $(searchNode).attr("name") + "' target='content' href='/" + "ord?" + $(searchNode).attr("ord") + pageFullscreen + "'>" + "<img src='"+ imageSearch +"' />" + "</a>");
				$(".nav-bar-iconpanel").append(anchorwithimg);
			} else {
				anchorwithimg = $("<a title='alarmnode' target='content' style='display:none'>" + "<img src='' id='alarmIcon' style='display:none'/>" + "</a>");
				$(".nav-bar-iconpanel").append(anchorwithimg);
				quickmenuCounter++; //increment if not in use
			}
			var infoNode = quickmenuElement.children[4];
			if($(infoNode).attr("ord") !== "none" && $(infoNode).attr("ord") !== "null" && $(infoNode).attr("ord") !== "") {
				var pageFullscreen;
				if ($(infoNode).attr("ord").includes("fullScreen=")) {
					pageFullscreen = "";
				} else if ($(infoNode).attr("ord").includes("view:")) {
					pageFullscreen = "?fullScreen=true";
				} else {
					pageFullscreen = "|view:?fullScreen=true";
				}
				anchorwithimg = $("<a title='" + $(infoNode).attr("name") + "' target='content' href='/" + "ord?" + $(infoNode).attr("ord") + pageFullscreen + "'>" + "<img src='"+ imageInfo +"' />" + "</a>");
				$(".nav-bar-iconpanel").append(anchorwithimg);
			} else {
				anchorwithimg = $("<a title='alarmnode' target='content' style='display:none'>" + "<img src='' id='alarmIcon' style='display:none'/>" + "</a>");
				$(".nav-bar-iconpanel").append(anchorwithimg);
				quickmenuCounter++; //increment if not in use
			}
			//Align quickmenu buttons to center if a button is missing.
			var quickmenuPadding = getComputedStyle(document.querySelector(".nav-bar-iconpanel"));
			var quickmenuPaddingNumber = parseInt(quickmenuPadding.paddingLeft.replace(/px/,""))
			quickmenuPaddingNumber = quickmenuPaddingNumber+25*quickmenuCounter;
			document.getElementsByClassName("nav-bar-iconpanel")[0].style.paddingLeft = quickmenuPaddingNumber +"px";
		}
		
		//Write text to buttons
		document.getElementsByClassName("btn_back")[0].value = orgLangToNew(langXmlDoc, "Back");
		document.getElementsByClassName("btn_next")[0].value = orgLangToNew(langXmlDoc, "Forward");


		if(alarmlistElement){
			//set name and ord for alarmlist prio 01
			if($(alarmlistElement.children[0]).attr("ord") !== "none" && $(alarmlistElement.children[0]).attr("ord") !== "null" && $(alarmlistElement.children[0]).attr("ord") !== "") {
				document.getElementById("headAlarmlistPrio01").innerHTML = $(alarmlistElement.children[0]).attr("name");
				if ($(alarmlistElement.children[0]).attr("ord").includes("fullScreen=")) {
					pageFullscreen = "";
				} else if ($(alarmlistElement.children[0]).attr("ord").includes("view:")) {
					pageFullscreen = "?fullScreen=true";
				} else {
					pageFullscreen = "|view:?fullScreen=true";
				}
				document.getElementById("headAlarmlistPrio01").setAttribute("onclick", "window.content.location.href='/ord?" + $(alarmlistElement.children[0]).attr("ord") + pageFullscreen + "'");
				document.getElementById("bodyAlarmlistPrio01").setAttribute("onclick", "window.content.location.href='/ord?" + $(alarmlistElement.children[0]).attr("ord") + pageFullscreen + "'");
				
				document.getElementById("headAlarmlistPrio01").setAttribute("style" , "");
				document.getElementById("bodyAlarmlistPrio01").setAttribute("style" , "");
			} else {
				
			}
		
			//set name and ord for alarmlist prio 02
			if($(alarmlistElement.children[1]).attr("ord") !== "none" && $(alarmlistElement.children[1]).attr("ord") !== "null" && $(alarmlistElement.children[1]).attr("ord") !== "") {
				document.getElementById("headAlarmlistPrio02").innerHTML = $(alarmlistElement.children[1]).attr("name");
				if ($(alarmlistElement.children[1]).attr("ord").includes("fullScreen=")) {
					pageFullscreen = "";
				} else if ($(alarmlistElement.children[1]).attr("ord").includes("view:")) {
					pageFullscreen = "?fullScreen=true";
				} else {
					pageFullscreen = "|view:?fullScreen=true";
				}
				document.getElementById("headAlarmlistPrio02").setAttribute("onclick", "window.content.location.href='/ord?" + $(alarmlistElement.children[1]).attr("ord") + pageFullscreen + "'");
				document.getElementById("bodyAlarmlistPrio02").setAttribute("onclick", "window.content.location.href='/ord?" + $(alarmlistElement.children[1]).attr("ord") + pageFullscreen + "'");
				
				document.getElementById("headAlarmlistPrio02").setAttribute("style" , "");
				document.getElementById("bodyAlarmlistPrio02").setAttribute("style" , "");
			} else {
				
				document.getElementById("headAlarmlistPrio02").setAttribute("style" , "display:none");
				document.getElementById("bodyAlarmlistPrio02").setAttribute("style" , "display:none");
			}
			
			//set name and ord for alarmlist prio 03
			if($(alarmlistElement.children[2]).attr("ord") !== "none" && $(alarmlistElement.children[2]).attr("ord") !== "null" && $(alarmlistElement.children[2]).attr("ord") !== "") {
				document.getElementById("headAlarmlistPrio03").innerHTML = $(alarmlistElement.children[2]).attr("name");
				if ($(alarmlistElement.children[2]).attr("ord").includes("fullScreen=")) {
					pageFullscreen = "";
				} else if ($(alarmlistElement.children[2]).attr("ord").includes("view:")) {
					pageFullscreen = "?fullScreen=true";
				} else {
					pageFullscreen = "|view:?fullScreen=true";
				}
				document.getElementById("headAlarmlistPrio03").setAttribute("onclick", "window.content.location.href='/ord?" + $(alarmlistElement.children[2]).attr("ord") + pageFullscreen + "'");
				document.getElementById("bodyAlarmlistPrio03").setAttribute("onclick", "window.content.location.href='/ord?" + $(alarmlistElement.children[2]).attr("ord") + pageFullscreen + "'");
				
				document.getElementById("headAlarmlistPrio03").setAttribute("style" , "");
				document.getElementById("bodyAlarmlistPrio03").setAttribute("style" , "");
			} else {
				
			}
			
			//set name and ord for alarmlist prio 04
			if($(alarmlistElement.children[3]).attr("ord") !== "none" && $(alarmlistElement.children[3]).attr("ord") !== "null" && $(alarmlistElement.children[3]).attr("ord") !== "") {
				document.getElementById("headAlarmlistPrio04").innerHTML = $(alarmlistElement.children[3]).attr("name");
				if ($(alarmlistElement.children[3]).attr("ord").includes("fullScreen=")) {
					pageFullscreen = "";
				} else if ($(alarmlistElement.children[3]).attr("ord").includes("view:")) {
					pageFullscreen = "?fullScreen=true";
				} else {
					pageFullscreen = "|view:?fullScreen=true";
				}
				document.getElementById("headAlarmlistPrio04").setAttribute("onclick", "window.content.location.href='/ord?" + $(alarmlistElement.children[3]).attr("ord") + pageFullscreen + "'");
				document.getElementById("bodyAlarmlistPrio04").setAttribute("onclick", "window.content.location.href='/ord?" + $(alarmlistElement.children[3]).attr("ord") + pageFullscreen + "'");
				
				document.getElementById("headAlarmlistPrio04").setAttribute("style" , "");
				document.getElementById("bodyAlarmlistPrio04").setAttribute("style" , "");
			} else {
				
			}
			//set name and ord for alarmlist prio 05
			if($(alarmlistElement.children[4]).attr("ord") !== "none" && $(alarmlistElement.children[4]).attr("ord") !== "null" && $(alarmlistElement.children[4]).attr("ord") !== "") {
				document.getElementById("headAlarmlistPrio05").innerHTML = $(alarmlistElement.children[4]).attr("name");
				if ($(alarmlistElement.children[4]).attr("ord").includes("fullScreen=")) {
					pageFullscreen = "";
				} else if ($(alarmlistElement.children[4]).attr("ord").includes("view:")) {
					pageFullscreen = "?fullScreen=true";
				} else {
					pageFullscreen = "|view:?fullScreen=true";
				}
				document.getElementById("headAlarmlistPrio05").setAttribute("onclick", "window.content.location.href='/ord?" + $(alarmlistElement.children[4]).attr("ord") + pageFullscreen + "'");
				document.getElementById("bodyAlarmlistPrio05").setAttribute("onclick", "window.content.location.href='/ord?" + $(alarmlistElement.children[4]).attr("ord") + pageFullscreen + "'");
				
				document.getElementById("headAlarmlistPrio05").setAttribute("style" , "");
				document.getElementById("bodyAlarmlistPrio05").setAttribute("style" , "");
			} else {
				
			}
		}
		finishHeader();
    /*setTimeout(function(){ 
    DEBUG && console.log('loadHeader cause first time');
    loadHeader(); 
    }, 1000);*/
		//loadHeader(); //load header after creation
	}
  function finishHeader() {
    if(document.getElementById('jPanelMenu-menu').style.display != '') {
      DEBUG && console.log('loadHeader cause first time');
      loadHeader();
    } else {
      DEBUG && console.log('loadHeader not ready');
      setTimeout(function(){ finishHeader(); }, 250);
    }
  }

	/* function to update the menu */
	function UpdateMenu() {

		var subUl = $('.example_menu ul'),
			subUlThird = $('#menu_wrapper ul ul ul');

		if (subUlThird.length) {
			subUlThird.css('display', 'none');
		}


		$('.example_menu a').click(function() {
			var parent = $(this),
				sib, subA;

			if (parent.hasClass('expanded')) {
				sib = parent.siblings('ul');
				subA = sib.find('a');
				subA.removeClass('expanded');
				subA.addClass('collapsed');
				sib.find('ul').css('display', 'none');
			}
		});

		$('#menu_wrapper ul ul a').click(function() {

			var e = $(this),
				ulSibling = e.siblings('ul');

			var siblingsA = e.parent('li').siblings('li').children('a');
			var siblingsLi = e.parent('li').siblings('li').children('ul');

			if (ulSibling.length) {
				e.toggleClass('collapsed');
				e.toggleClass('expanded');

				if (ulSibling.css('display') === 'block') {
					ulSibling.css('display', 'none');
					siblingsLi.css('display', 'none');

					if (siblingsA.hasClass('expanded')) {
						siblingsA.removeClass('expanded');
						siblingsA.addClass('collapsed');
					}

				} else {
					ulSibling.css('display', 'block');

				}
			}
		});
	}

	/* function to collapse the menu */
	$("#menu5 > li > a.expanded + ul").slideToggle(200);

	$(document).on("click", "#menu5 > li > a", function() {

	    $("#menu5 > li > a.expanded").not(this).toggleClass("expanded").toggleClass("collapsed").parent().find('> ul').slideToggle(200);
	    $(this).toggleClass("expanded").toggleClass("collapsed").parent().find('> ul').slideToggle(200);

	    $("#content").attr("src", $(this).attr('href'));

	    return false;
	});

	//loading header if window is resized
	$(window).resize(function() {
		if(loadheaderFirstTime){
			DEBUG && console.log('loadHeader cause of Resize');
			loadHeader();
		}

	});

	//loading header if wrapper button is clicked
	$(document).ready(function () {
	    $(".menu-trigger").on('click touchend', function (e) {
		   DEBUG && console.log('loadHeader cause of Menu-Trigger');
		   setTimeout(() => {  loadHeader(); }, 410);
		   e.preventDefault();
	    });
		  $(document).on('keydown', function(e) {
			    setTimeout(() => {  loadHeader(); }, 410);
		   e.preventDefault();
		  });
	});


	//setup vars in scope for load header
	var loadheaderFirstTime = false;
	var headerTextWidth = 0;
	var headerDetailsWidth = 0;
	var AlarmPrioWidth = new Array(6);
	var headerLogoWidth = 0;
	var headerDefaultWidth = 125;//benötigt 40+36+10+17+17 (Hamburger & Logout &padding & margin)

	//setup header if the width of elements or from the windows are changed. 
	function loadHeader() {
		DEBUG && console.group('*****loadHeader Function*****');
		//get header Text width
		if(!loadheaderFirstTime) {
		  DEBUG && console.group('*****First time Init*****');
			var headetTextElement = document.getElementById('userdefined-text');
			var headerTextPositionInfo = headetTextElement.getBoundingClientRect();
			headerTextWidth = Math.round(headerTextPositionInfo.width) + 24;
			DEBUG && console.log('headerTextWidth: ' + headerTextWidth);
			//get Alarm width
			var AlarmPrioElement = new Array(6);
			var AlarmPrioPositionInfo = new Array(6);
			//AlarmPrioWidth = new Array(6);
			for (var i = 1; i < 6; i++) {
				AlarmPrioElement[i] = document.getElementById('headAlarmlistPrio0'+ i);
				AlarmPrioPositionInfo[i] = AlarmPrioElement[i].getBoundingClientRect();
				AlarmPrioWidth[i] = Math.round(AlarmPrioPositionInfo[i].width);
				DEBUG && console.log('AlarmPrioWidth[' + i + ']: ' + AlarmPrioWidth[i]);
			}

			var headerDetailsElement = document.getElementsByClassName('header-details')[0];
			var headerDetailsPositionInfo = headerDetailsElement.getBoundingClientRect();
			headerDetailsWidth = Math.round(headerDetailsPositionInfo.width);
			DEBUG && console.log('headerDetailsWidth: ' + headerDetailsWidth);
			var headerLogoElement = document.getElementsByClassName('header-text-logo')[0];
			var headerLogoPositionInfo = headerLogoElement.getBoundingClientRect();
			headerLogoWidth = Math.round(headerLogoPositionInfo.width);
			DEBUG && console.log('headerLogoWidth: ' + headerLogoWidth);
			DEBUG && console.groupEnd();
			loadheaderFirstTime = true;
		}
    if(document.getElementsByClassName('header-text-logo')[0].style.display != "none") {
      var headerLogoElement = document.getElementsByClassName('header-text-logo')[0];
			var headerLogoPositionInfo = headerLogoElement.getBoundingClientRect();
			var headerLogoWidthTemp = Math.round(headerLogoPositionInfo.width);
			if((headerLogoWidth != headerLogoWidthTemp) && (headerLogoWidthTemp != 70)){
			  headerLogoWidth = headerLogoWidthTemp;
			  DEBUG && console.log('headerLogoWidth has changed: ' + headerLogoWidth);
			}
    }
		var sizeOfHeader = headerDefaultWidth + headerTextWidth + headerDetailsWidth + AlarmPrioWidth[1] + AlarmPrioWidth[2] + AlarmPrioWidth[3] + AlarmPrioWidth[4] + AlarmPrioWidth[5] + headerLogoWidth;
		//var headerElement = document.getElementsByClassName('header')[0];
		//var headerPositionInfo = headerElement.getBoundingClientRect();
		var maxHeaderSize = 0;//Math.round(headerPositionInfo.width);
		var jPanelMenuElement = document.getElementById('jPanelMenu-menu');
		var jPanelMenuPositionInfo = jPanelMenuElement.getBoundingClientRect();
		var jPanelMenuWidth = Math.round(jPanelMenuPositionInfo.width);
		DEBUG && console.log('jPanelMenuStatus: ' + document.getElementById('jPanelMenu-menu').style.display);
		if(document.getElementById('jPanelMenu-menu').style.display === "none"){
			maxHeaderSize = document.body.clientWidth;
		} else {
			maxHeaderSize = document.body.clientWidth - jPanelMenuWidth;
		}
		DEBUG && console.log('maxHeaderSize: ' + maxHeaderSize);
		DEBUG && console.log('sizeOfHeader: ' + sizeOfHeader);
		if(sizeOfHeader > maxHeaderSize) {
			document.getElementsByClassName('header-text-logo')[0].style.display = "none";
			sizeOfHeader = sizeOfHeader - headerLogoWidth;
			DEBUG && console.log("header-text-logo off");
		} else {
			document.getElementsByClassName('header-text-logo')[0].style.display = "";
			DEBUG && console.log("header-text-logo on");
		}        

		if(sizeOfHeader > maxHeaderSize) {
			document.getElementById('userdefined-text').style.display = "none";
			sizeOfHeader = sizeOfHeader - headerTextWidth;
			DEBUG && console.log("userdefined-text off");
		} else {
			document.getElementById('userdefined-text').style.display = "";
			DEBUG && console.log("userdefined-text on");
		}
		if(AlarmPrioWidth[5] !== 0){    
			if(sizeOfHeader > maxHeaderSize) {
				document.getElementById('headAlarmlistPrio05').style.display = "none";
				document.getElementById('bodyAlarmlistPrio05').style.display = "none";
				sizeOfHeader = sizeOfHeader - AlarmPrioWidth[5];
				DEBUG && console.log("headAlarmlistPrio05 off");                     
			} else {
				document.getElementById('headAlarmlistPrio05').style.display = "";
				document.getElementById('bodyAlarmlistPrio05').style.display = "";
				DEBUG && console.log("headAlarmlistPrio05 on");
			}    
		}
		if(AlarmPrioWidth[4] !== 0){
			if(sizeOfHeader > maxHeaderSize) {
				document.getElementById('headAlarmlistPrio04').style.display = "none";
				document.getElementById('bodyAlarmlistPrio04').style.display = "none";
				sizeOfHeader = sizeOfHeader - AlarmPrioWidth[4];
				DEBUG && console.log("headAlarmlistPrio04 off");
			} else {
				document.getElementById('headAlarmlistPrio04').style.display = "";
				document.getElementById('bodyAlarmlistPrio04').style.display = "";
				DEBUG && console.log("headAlarmlistPrio04 on");
			}
		}
		if(AlarmPrioWidth[3] !== 0){    
			if(sizeOfHeader > maxHeaderSize) {
				document.getElementById('headAlarmlistPrio03').style.display = "none";
				document.getElementById('bodyAlarmlistPrio03').style.display = "none";
				sizeOfHeader = sizeOfHeader - AlarmPrioWidth[3];
				DEBUG && console.log("headAlarmlistPrio03 off");
			} else {
				document.getElementById('headAlarmlistPrio03').style.display = "";
				document.getElementById('bodyAlarmlistPrio03').style.display = "";
				DEBUG && console.log("headAlarmlistPrio03 on");
			}
		}
		if(AlarmPrioWidth[2] !== 0){
			if(sizeOfHeader > maxHeaderSize) {
				document.getElementById('headAlarmlistPrio02').style.display = "none";
				document.getElementById('bodyAlarmlistPrio02').style.display = "none";
				sizeOfHeader = sizeOfHeader - AlarmPrioWidth[2];
				DEBUG && console.log("headAlarmlistPrio02 off");
			} else {
				document.getElementById('headAlarmlistPrio02').style.display = "";
				document.getElementById('bodyAlarmlistPrio02').style.display = "";
				DEBUG && console.log("headAlarmlistPrio02 on");
			}
		}
		if(AlarmPrioWidth[1] !== 0){
			if(sizeOfHeader > maxHeaderSize) {
				document.getElementById('headAlarmlistPrio01').style.display = "none";
				document.getElementById('bodyAlarmlistPrio01').style.display = "none";
				sizeOfHeader = sizeOfHeader - AlarmPrioWidth[1];
				DEBUG && console.log("headAlarmlistPrio01 off");
			} else {
				document.getElementById('headAlarmlistPrio01').style.display = "";
				document.getElementById('bodyAlarmlistPrio01').style.display = "";
				DEBUG && console.log("headAlarmlistPrio01 on");
			}
		}
		if(sizeOfHeader > maxHeaderSize) {
			document.getElementsByClassName('header-details')[0].style.display = "none";
			sizeOfHeader = sizeOfHeader - headerDetailsWidth;
			DEBUG && console.log("header-details off");
		} else {
			document.getElementsByClassName('header-details')[0].style.display = "";
			DEBUG && console.log("header-details on");
		}
		DEBUG && console.groupEnd();
	}
});
